import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
//import java.applet.*;
import java.net.*;
import java.text.*;

public class CrpcFrame extends JInternalFrame {
  // GUI variables 
    private JButton Button1,Button2,Button3,Button4,Button5,Button6;
    private JButton Buttonrm, Buttonrm1;   //cyoun
    private JTextField status;
    private int CurrentVariable;
    private JTextArea resultText, sc;
    private JProgressBar progress;
    private JScrollPane sp;
    private desktop a;
    private String Server=" ";
    String nextLine;
    String resultFile = "result.txt";
    private boolean debug = true;
    private static boolean ExecutionCompleted;
    private Thread exeA;
    private Thread exeB, exeC;
    private Thread exeP;

   public CrpcFrame(desktop a) {

   super("Adcirc", true, true, true, true);
   this.a = a;
   ExecutionCompleted=false;

  /* menu bar 
   ActionListener mListener = new ActionListener() {
       public void actionPerformed(ActionEvent e) {
       dispose();
   }
  };


  if(debug) System.out.println("menu bar");
  MenuBar menubar = new MenuBar();
  Menu menuFile = new Menu("File");
  MenuItem exitItem = new MenuItem("close this window");
  exitItem.addActionListener(mListener);
  menuFile.add(exitItem);
  menubar.add(menuFile);
  setMenuBar(menubar);
  */

  if(debug) System.out.println("build GUI");

  getContentPane().setLayout(new BorderLayout());
  
  JPanel left=new JPanel();           //input parameters
  JPanel right=new JPanel();          //results
  JPanel south=new JPanel();         //progress bar;

  getContentPane().add(left,BorderLayout.WEST);
  getContentPane().add(right,BorderLayout.CENTER);
  getContentPane().add(south,BorderLayout.SOUTH);

  if(debug) System.out.println("input parameters  (left panel)");

  JPanel up=new JPanel();             // label (logo)
  JPanel centerPanel = new JPanel();  // input params and scenarios
    //    Panel middle=new Panel();         // input params
  JPanel scenarios = new JPanel();    // scenarios
  JPanel bottom=new JPanel();         // action buttons

  left.setLayout(new BorderLayout());
  left.add(up,BorderLayout.NORTH);
  left.add(centerPanel,BorderLayout.CENTER);
  left.add(bottom,BorderLayout.SOUTH);

  centerPanel.setLayout(new BorderLayout()); 
    //centerPanel.add(middle,BorderLayout.CENTER);
  centerPanel.add(scenarios,BorderLayout.SOUTH);

  if(debug) System.out.println("MSU logo");
  up.setLayout(new BorderLayout());
  JLabel LogoLabel = new JLabel("CRPC Portal",JLabel.CENTER);
  LogoLabel.setFont(new Font("arun",Font.BOLD,30));
  up.add(LogoLabel,BorderLayout.CENTER);
  status=new JTextField("welcome!",20);
  up.add(status,BorderLayout.SOUTH);
    
  if(debug) System.out.println("input params");
  
  bottom.setLayout(new GridLayout(3,2,5,0));

  if(debug) System.out.println("action  buttons");
  Button1 = new JButton ("Run CRPC Portal");
  Buttonrm = new JButton ("Remove File(heechee)");
  Buttonrm1 = new JButton ("Remove Remote File(oscbw)");
  bottom.add(Button1);
  bottom.add(Buttonrm);
  bottom.add(Buttonrm1);

  if(debug) System.out.println("button action Events");

/*
     Button1.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent ev) {
          String helpfile="help.txt"; 
          printHelpFile(helpfile);
        }
     });

     Button2.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent ev) {
          // reset
	}
     });

     Button3.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent ev) {
	  // run ls
          runIt("/usr/bin/ls");
        }
     });

     Button4.addActionListener(new ActionListener() {
     public void actionPerformed(ActionEvent ev) {
     // run Adcirc
     runIt("/home/haupt/runIt.pl");
     }
     });
*/

  
  Buttonrm.addActionListener(new ActionListener() {
	  public void actionPerformed(ActionEvent ev1) {

	      String dest = "/home/webrun/";     
	      while (Connection.remote.exists(dest+"velTime"))  
		  Connection.remote.delete(dest+"velTime");

	      String rm_vel;
	      for (int i = 0; i < 10; i++) {
		  rm_vel = "vel.00" + i + ".plt" ;
		  while (Connection.remote.exists(dest+rm_vel))
		      Connection.remote.delete(dest+rm_vel);
	      }
	      for (int i = 10; i < 25; i++) {
		  rm_vel = "vel.0" + i + ".plt" ;
		  while (Connection.remote.exists(dest+rm_vel))
		      Connection.remote.delete(dest+rm_vel);
	      }

	      while (Connection.remote.exists(dest+"presTime"))  
		  Connection.remote.delete(dest+"presTime");

	      String rm_pres;
	      for (int i = 0; i < 10; i++) {
		  rm_pres = "pres.00" + i + ".plt" ;

		  while (Connection.remote.exists(dest+rm_pres))
		      Connection.remote.delete(dest+rm_pres);
	      }
	      for (int i = 10; i < 25; i++) {
		  rm_pres = "pres.0" + i + ".plt" ;
		  while (Connection.remote.exists(dest+rm_pres))
		      Connection.remote.delete(dest+rm_pres);
	      }

	      while (Connection.remote.exists(dest+"concTime"))
		  Connection.remote.delete(dest+"concTime");

	      String rm_conc1, rm_conc11, rm_conc21;
	      for (int i = 0; i < 10; i++) {
		  rm_conc1 = "conc1-10.00" + i + ".plt" ;
		  rm_conc11 = "conc11-20.00" + i + ".plt" ;
		  rm_conc21 = "conc21-27.00" + i + ".plt" ;

		  while (Connection.remote.exists(dest+rm_conc1))
		      Connection.remote.delete(dest+rm_conc1);

		  while (Connection.remote.exists(dest+rm_conc11))
		      Connection.remote.delete(dest+rm_conc11);

		  while (Connection.remote.exists(dest+rm_conc21))
		      Connection.remote.delete(dest+rm_conc21);
	      }
	      for (int i = 10; i < 31; i++) {
		  rm_conc1 = "conc1-10.0" + i + ".plt" ;
		  rm_conc11 = "conc11-20.0" + i + ".plt" ;
		  rm_conc21 = "conc21-27.0" + i + ".plt" ;

		  while (Connection.remote.exists(dest+rm_conc1))
		      Connection.remote.delete(dest+rm_conc1);

		  while (Connection.remote.exists(dest+rm_conc11))
		      Connection.remote.delete(dest+rm_conc11);

		  while (Connection.remote.exists(dest+rm_conc21))
		      Connection.remote.delete(dest+rm_conc21);
	      }

	  }
      });

  Buttonrm1.addActionListener(new ActionListener() {
	  public void actionPerformed(ActionEvent ev2) {

	      String host = "oscbw.osc.edu";
	      String user = "pse";
	      String cmdLine = "rm /home/pse/CRPC/beowulf/";

	      Connection.submit.submitRsh(host, user, cmdLine+"velTime");

	      String rm_vel;
	      for (int i = 0; i < 10; i++) {
		  rm_vel = "vel.00" + i + ".plt" ;
		  Connection.submit.submitRsh(host, user, cmdLine+rm_vel);
	      }
	      for (int i = 10; i < 25; i++) {
		  rm_vel = "vel.0" + i + ".plt" ;
		  Connection.submit.submitRsh(host, user, cmdLine+rm_vel);
	      }

	      Connection.submit.submitRsh(host, user, cmdLine+"presTime");
	      String rm_pres;
	      for (int i = 0; i < 10; i++) {
		  rm_pres = "pres.00" + i + ".plt" ;
		  Connection.submit.submitRsh(host, user, cmdLine+rm_pres);
	      }
	      for (int i = 10; i < 25; i++) {
		  rm_pres = "pres.0" + i + ".plt" ;
		  Connection.submit.submitRsh(host, user, cmdLine+rm_pres);
	      }

	      Connection.submit.submitRsh(host, user, cmdLine+"concTime");
	      String rm_conc1, rm_conc11, rm_conc21;
	      for (int i = 0; i < 10; i++) {
		  rm_conc1 = "conc1-10.00" + i + ".plt" ;
		  rm_conc11 = "conc11-20.00" + i + ".plt" ;
		  rm_conc21 = "conc21-27.00" + i + ".plt" ;

		  Connection.submit.submitRsh(host, user, cmdLine+rm_conc1);
		  Connection.submit.submitRsh(host, user, cmdLine+rm_conc11);
		  Connection.submit.submitRsh(host, user, cmdLine+rm_conc21);
	      }

	      for (int i = 10; i < 31; i++) {
		  rm_conc1 = "conc1-10.0" + i + ".plt" ;
		  rm_conc11 = "conc11-20.0" + i + ".plt" ;
		  rm_conc21 = "conc21-27.0" + i + ".plt" ;
		  Connection.submit.submitRsh(host, user, cmdLine+rm_conc1);
		  Connection.submit.submitRsh(host, user, cmdLine+rm_conc11);
		  Connection.submit.submitRsh(host, user, cmdLine+rm_conc21);
	      }
	  }
      });

  Button1.addActionListener(new ActionListener() {
	  public void actionPerformed(ActionEvent ev) {
	      //	  runIt("xterm -display wonderdog.npac.syr.edu:0.0") ;
	      //runIt("/usr/bin/ls");
	      //* added for CRPC portal
	      //runIt("/usr/bin/rm /home/webrun/vel.*.plt");
	      //runIt("/usr/bin/cp /home/youn/velTime /home/webrun/velTime");
	      runIt("rsh -l pse oscbw.osc.edu /usr/local/pbs-2.2.11/bin/qsub /home/pse/CRPC/beowulf/job.qsub") ;
	      //runIt("/usr/bin/rcp pse@oscbw.osc.edu:/home/pse/CRPC/beowulf/vel.000.plt /home/webrun/");
	      // Things left for CRPC portal test   runIt("start express" ;	
	      // to start display application -- "express"
	      CrpcSendvel();
	      //CrpcSendpres();
	      //CrpcSendconc();
	  }
      });

  if(debug) System.out.println("do scroll pane");

  /* results (right panel) */

// text area with Scrollbar

/* replaced by swing
   Panel upright=new Panel(new FlowLayout());
   right.setLayout(new BorderLayout());
   right.add(upright,BorderLayout.CENTER);  
   resultText = new TextArea();
   resultText.setFont(new Font("Courier", Font.PLAIN, 12));
   right.add(resultText);   }
  */

right.setLayout(new BorderLayout());
resultText = new JTextArea();
resultText.setFont(new Font("Courier", Font.PLAIN, 12));
sp = new JScrollPane(resultText);
right.add(sp,BorderLayout.CENTER);

/*  progress = new JProgressBar(0,100);
    progress.setPreferredSize(new Dimension(400,20));
    south.add(progress); */
   } 

    public void printHelpFile(String helpfile) {
	status.setText("sorry, not available");
    }

    public void runIt(String command) {
	ExeCrpc ea = new ExeCrpc(status,resultText,sp,command,debug);
	exeA = new Thread(ea);
	exeA.start();
    }

    /* for CRPC portal */
    public void CrpcSendvel() {
	CrpcDisplay ea = new CrpcDisplay(status,resultText,sp,"vel",debug);
	exeB = new Thread(ea);
	exeB.start();    
    }

    public void CrpcSendpres() {
	CrpcDisplay ea = new CrpcDisplay(status,resultText,sp,"pres",debug);
	exeP = new Thread(ea);
	exeP.start();    
    }

    public void CrpcSendconc() {
	CrpcDisplay ea = new CrpcDisplay(status,resultText,sp,"conc",debug);
	exeC = new Thread(ea);
	exeC.start();    
    }

    public void ShowData(String page) {
	status.setText("sorry, not available");
	/*
	  try {
	  URL pageurl = new URL(Server+page);
	  ac.showDocument(pageurl,"results");
	  }
	  catch (Exception e) {if(debug) System.out.println(e);}
	*/
    } 

    public synchronized void waitFor(long howLong){
	try {
	    wait(howLong);
	} catch (Exception e) { System.out.println(e);}
    }

    public static void setExecutionCompleted() {
	ExecutionCompleted=true;
    }

    public static boolean getExecutionCompleted() {
	return ExecutionCompleted;
    }
    }





















